function [scores, img_ids, A]=querysp(qvw, qgeom, bbx, vw, geom, DB, idf, opt)
   
   if (~isempty(bbx))
      qidx = ptsinbbx(qgeom, bbx);
   else
      qidx = 1:size(qgeom,2);
   end;
   
   % tf-idf query sorts all images
   [img_ids, scores] = query(DB, qvw(qidx), idf);
   
   max_spatial = 100;
   if (isfield(opt, 'max_spatial'))
      max_spatial = opt.max_spatial;
   end;
   
   max_spatial = min(numel(img_ids), max_spatial);
   
   % prepare resulting transformations
   A = zeros(3,3,numel(img_ids));
   
   % find correspondences
   t=cputime; corrs = corrm2m(qvw(qidx), vw, img_ids(1:max_spatial), opt); t=cputime-t; 
   fprintf('\nCorrespondences in %.3f sec.\n', t);
   
   % verify them
   t=cputime; [scores_sp A(:,:,1:max_spatial)] = ransacm2m(qgeom(:,qidx), geom, corrs, img_ids(1:max_spatial), opt); t=cputime-t;
   fprintf('Verified in %.3f sec.\n', t);
   
   % renew scores...
   scores(1:max_spatial)=scores(1:max_spatial)+scores_sp;
   
   [scores ord]=sort(scores, 'descend');
   
   img_ids=img_ids(ord);
   A = A(:,:,ord);