function [scores, A]=ransacm2m(qgeom, geom, corrs, relevant, opt)
   
   if (~isfield(opt, 'threshold'))
      opt.threshold = 8;
   end;
   threshold = opt.threshold*opt.threshold;
   
   scores = zeros(1,numel(relevant));
   A = zeros(3,3,numel(relevant));
   
   % prepare query transformations
   Q = arrayfun(@(x,y,a11,a12,a21,a22) inv([a11,a12,x;a21,a22,y;0 0 1]), qgeom(1,:), qgeom(2,:), qgeom(3,:), qgeom(4,:), ...
                qgeom(5,:), qgeom(6,:), 'uniformoutput', false);
   pts1 = qgeom(1:2,:);
   pts1(3,:) = 1;
      
   for i=1:numel(relevant)
      dgeom = geom{relevant(i)}; corr = corrs{i};
      if (isempty(corr))
         continue;
      end;
      D = arrayfun(@(x,y,a11,a12,a21,a22) [a11,a12,x;a21,a22,y;0 0 1], dgeom(1,:), dgeom(2,:), dgeom(3,:), dgeom(4,:), ...
                dgeom(5,:), dgeom(6,:), 'uniformoutput', false);
      
      % hypothesise
      T = cellfun(@(Q,D) D*Q, Q(corr(1,:)), D(corr(2,:)), 'uniformoutput', false);
      % test
      pts2 = dgeom(1:2,corr(2,:));
      inls = cellfun(@(t) sum(adist(t, pts1(:,corr(1,:)), pts2)<threshold), T);
      [score idx] = max(inls);
      scores(i) = score;
      A(:,:,i) = T{idx};
   end;